int atmega103_int[]={
  RESET,INT0,INT1,INT2,INT3,INT4,INT5,INT6,INT7,TIMER2_COMP,TIMER2_OVF,
  TIMER1_CAPT,TIMER1_COMPA,TIMER1_COMPB,TIMER1_OVF,TIMER0_COMP,TIMER0_OVF,
  SPI_STC,UART0_RX,UART0_UDRE,UART0_TX,ADC,EE_READY,ANALOG_COMP,-1};


IO_port atmega103_io[]={
  {SREG,  0x3F,0xFF,0xFF,0},
  {SPH,   0x3E,0xFF,0xFF,0},
  {SPL,   0x3D,0xFF,0xFF,0},
  {XDIV,  0x3C,0xFF,0xFF,0},
  {RAMPZ, 0x3B,0x01,0x01,0},
  {EICR,  0x3A,0xFF,0xFF,0},
  {EIMSK, 0x39,0xFF,0xFF,0},
  {EIFR,  0x38,0xF0,0xF0,0},
  {TIMSK, 0x37,0xFF,0xFF,0},
  {TIFR,  0x36,0xFF,0xFF,0},
  {MCUCR, 0x35,0xF8,0xF8,0},
  {MCUSR, 0x34,0x03,0x03,0},
  {TCCR0, 0x33,0x7F,0x7F,0},
  {TCNT0, 0x32,0xFF,0xFF,0},
  {OCR0,  0x31,0xFF,0xFF,0},
  {ASSR,  0x30,0x08,0x0F,0},
  {TCCR1A,0x2F,0xF3,0xF3,0},
  {TCCR1B,0x2E,0xCF,0xCF,0},
  {TCNT1H,0x2D,0xFF,0xFF,0},
  {TCNT1L,0x2C,0xFF,0xFF,0},
  {OCR1AH,0x2B,0xFF,0xFF,0},
  {OCR1AL,0x2A,0xFF,0xFF,0},
  {OCR1BH,0x29,0xFF,0xFF,0},
  {OCR1BL,0x28,0xFF,0xFF,0},
  {ICR1H, 0x27,0,0xFF,0},
  {ICR1L, 0x26,0,0xFF,0},
  {TCCR2, 0x25,0x7F,0x7F,0},
  {TCNT2, 0x24,0xFF,0xFF,0},
  {OCR2,  0x23,0xFF,0xFF,0},
  {WDTCR, 0x21,0x1F,0x1F,0},
  {EEARH, 0x1F,0x0F,0x0F,0},
  {EEARL, 0x1E,0xFF,0xFF,0},
  {EEDR,  0x1D,0xFF,0xFF,0},
  {EECR,  0x1C,0x0F,0x0F,0},
  {PORTA, 0x1B,0xFF,0xFF,0},
  {DDRA,  0x1A,0xFF,0xFF,0},
  {PINA,  0x19,0,0xFF,0},
  {PORTB, 0x18,0xFF,0xFF,0},
  {DDRB,  0x17,0xFF,0xFF,0},
  {PINB,  0x16,0x00,0xFF,0},
  {PORTC, 0x15,0xFF,0xFF,0},
  {PORTD, 0x12,0xFF,0xFF,0},
  {DDRD,  0x11,0xFF,0xFF,0},
  {PIND,  0x10,0,0xFF,0},
  {SPDR,  0x0F,0xFF,0xFF,0},
  {SPSR,  0x0E,0,0xC0,0},
  {SPCR,  0x0D,0xFF,0xFF,0},
  {UDR0,  0x0C,0xFF,0xFF,0},
  {UCSR0A,0x0B,0x40,0xF8,0x20},
  {UCSR0B,0x0A,0xFD,0xFF,0x02},
  {UBRR0L,0x09,0xFF,0xFF,0},
  {ACSR,  0x08,0x9F,0xBF,0},
  {ADMUX, 0x07,0x07,0x07,0},
  {ADCSR, 0x06,0xDF,0xDF,0},
  {ADCH,  0x05,0,0x03,0},
  {ADCL,  0x04,0,0xFF,0},
  {PORTE, 0x03,0xFF,0xFF,0},
  {DDRE,  0x02,0xFF,0xFF,0},
  {PINE,  0x01,0,0xFF,0},
  {PINF,  0x00,0,0xFF,0},
  {-1,0,0,0}
};


Pin atmega103_pins[]={
  {SS_PIN,  0x18,0x16,1<<0},
  {SCK_PIN, 0x18,0x16,1<<1},
  {MOSI_PIN,0x18,0x16,1<<2},
  {MISO_PIN,0x18,0x16,1<<3},
  {OC0_PIN, 0x18,0x16,1<<4},{PWM0_PIN, 0x18,0x16,1<<4},
  {OC1A_PIN,0x18,0x16,1<<5},{PWM1A_PIN,0x18,0x16,1<<5},
  {OC1B_PIN,0x18,0x16,1<<6},{PWM1B_PIN,0x18,0x16,1<<6},
  {OC2_PIN, 0x18,0x16,1<<7},{PWM2_PIN, 0x18,0x16,1<<7},

  {INT0_PIN,0x12,0x10,1<<0},
  {INT1_PIN,0x12,0x10,1<<1},
  {INT2_PIN,0x12,0x10,1<<2},
  {INT3_PIN,0x12,0x10,1<<3},
  {IC1_PIN, 0x12,0x10,1<<4},
  {T1_PIN,  0x12,0x10,1<<6},
  {T2_PIN,  0x12,0x10,1<<7},

  {RXD0_PIN,0x03,0x01,1<<0},{PDI_PIN, 0x03,0x01,1<<0},
  {TXD0_PIN,0x03,0x01,1<<1},{PDO_PIN, 0x03,0x01,1<<1},
  {AIN0_PIN,0x03,0x01,1<<2},
  {AIN1_PIN,0x03,0x01,1<<3},
  {INT4_PIN,0x03,0x01,1<<4},
  {INT5_PIN,0x03,0x01,1<<5},
  {INT6_PIN,0x03,0x01,1<<6},
  {INT7_PIN,0x03,0x01,1<<7},

  {ADC0_PIN,0x00,0x00,1<<0},
  {ADC1_PIN,0x00,0x00,1<<1},
  {ADC2_PIN,0x00,0x00,1<<2},
  {ADC3_PIN,0x00,0x00,1<<3},
  {ADC4_PIN,0x00,0x00,1<<4},
  {ADC5_PIN,0x00,0x00,1<<5},
  {ADC6_PIN,0x00,0x00,1<<6},
  {ADC7_PIN,0x00,0x00,1<<7},
  {-1,0,0,0}
};

Flag atmega103_flags[]={
  {ISC40_FLAG, EICR,  1<<0},
  {ISC41_FLAG, EICR,  1<<1},
  {ISC50_FLAG, EICR,  1<<2},
  {ISC51_FLAG, EICR,  1<<3},
  {ISC60_FLAG, EICR,  1<<4},
  {ISC61_FLAG, EICR,  1<<5},
  {ISC70_FLAG, EICR,  1<<6},
  {ISC71_FLAG, EICR,  1<<7},
  
  {INT0_FLAG,  EIMSK, 1<<0},
  {INT1_FLAG,  EIMSK, 1<<1},
  {INT2_FLAG,  EIMSK, 1<<2},
  {INT3_FLAG,  EIMSK, 1<<3},
  {INT4_FLAG,  EIMSK, 1<<4},
  {INT5_FLAG,  EIMSK, 1<<5},
  {INT6_FLAG,  EIMSK, 1<<6},
  {INT7_FLAG,  EIMSK, 1<<7},
  
  {INTF4_FLAG, EIFR,  1<<4},
  {INTF5_FLAG, EIFR,  1<<5},
  {INTF6_FLAG, EIFR,  1<<6},
  {INTF7_FLAG, EIFR,  1<<7},

  {TOIE0_FLAG, TIMSK, 1<<0},
  {OCIE0_FLAG, TIMSK, 1<<1},
  {TOIE1_FLAG, TIMSK, 1<<2},
  {OCIE1B_FLAG,TIMSK, 1<<3},
  {OCIE1A_FLAG,TIMSK, 1<<4},
  {TICIE1_FLAG,TIMSK, 1<<5},
  {TOIE2_FLAG, TIMSK, 1<<6},
  {OCIE2_FLAG, TIMSK, 1<<7},
  
  {TOV0_FLAG,  TIFR,  1<<0},
  {OCF0_FLAG,  TIFR,  1<<1},
  {TOV1_FLAG,  TIFR,  1<<2},
  {OCF1B_FLAG, TIFR,  1<<3},
  {OCF1A_FLAG, TIFR,  1<<4},
  {ICF1_FLAG,  TIFR,  1<<5},
  {TOV2_FLAG,  TIFR,  1<<6},
  {OCF2_FLAG,  TIFR,  1<<7},

  {SM0_FLAG,   MCUCR, 1<<3},
  {SM1_FLAG,   MCUCR, 1<<4},
  {SE_FLAG,    MCUCR, 1<<5},
  {SRW_FLAG,   MCUCR, 1<<6},
  {SRE_FLAG,   MCUCR, 1<<7},

  {PORF_FLAG,  MCUSR, 1<<0},   
  {EXTRF_FLAG, MCUSR, 1<<1},    
  
  {CS00_FLAG,  TCCR0, 1<<0},
  {CS01_FLAG,  TCCR0, 1<<1},
  {CS02_FLAG,  TCCR0, 1<<2},
  {CTC0_FLAG,  TCCR0, 1<<3},
  {COM00_FLAG, TCCR0, 1<<4},
  {COM01_FLAG, TCCR0, 1<<5},
  {PWM0_FLAG,  TCCR0, 1<<6},

  {TCR2UB_FLAG,ASSR,  1<<0},
  {OCR2UB_FLAG,ASSR,  1<<1},
  {TCN2UB_FLAG,ASSR,  1<<2},
  {AS2_FLAG,   ASSR,  1<<3},

  {PWM10_FLAG, TCCR1A,1<<0},
  {PWM11_FLAG, TCCR1A,1<<1},
  {COM1B0_FLAG,TCCR1A,1<<4},
  {COM1B1_FLAG,TCCR1A,1<<5},
  {COM1A0_FLAG,TCCR1A,1<<6},
  {COM1A1_FLAG,TCCR1A,1<<7},

  {CS10_FLAG,  TCCR1B,1<<0},
  {CS11_FLAG,  TCCR1B,1<<1},
  {CS12_FLAG,  TCCR1B,1<<2},
  {CTC1_FLAG,  TCCR1B,1<<3},
  {ICES1_FLAG, TCCR1B,1<<6},
  {ICNC1_FLAG, TCCR1B,1<<7},

  {CS20_FLAG,  TCCR2, 1<<0},
  {CS21_FLAG,  TCCR2, 1<<1},
  {CS22_FLAG,  TCCR2, 1<<2},
  {CTC2_FLAG,  TCCR2, 1<<3},
  {COM20_FLAG, TCCR2, 1<<4},
  {COM21_FLAG, TCCR2, 1<<5},
  {PWM2_FLAG,  TCCR2, 1<<6},

  {WDP0_FLAG,  WDTCR, 1<<0},
  {WDP1_FLAG,  WDTCR, 1<<1},
  {WDP2_FLAG,  WDTCR, 1<<2},
  {WDE_FLAG,   WDTCR, 1<<3},
  {WDTOE_FLAG, WDTCR, 1<<4},

  {EERE_FLAG,  EECR,  1<<0},
  {EEWE_FLAG,  EECR,  1<<1},
  {EEMWE_FLAG, EECR,  1<<2},
  {EERIE_FLAG, EECR,  1<<3},

  {WCOL_FLAG,  SPSR,  1<<6},
  {SPIF_FLAG,  SPSR,  1<<7},

  {SPR0_FLAG,  SPCR,  1<<0},
  {SPR1_FLAG,  SPCR,  1<<1},
  {CPHA_FLAG,  SPCR,  1<<2},
  {CPOL_FLAG,  SPCR,  1<<3},
  {MSTR_FLAG,  SPCR,  1<<4},
  {DORD_FLAG,  SPCR,  1<<5},
  {SPE_FLAG,   SPCR,  1<<6},
  {SPIE_FLAG,  SPCR,  1<<7},

  {OR0_FLAG,    UCSR0A,1<<3},
  {FE0_FALG,    UCSR0A,1<<4},
  {UDRE0_FLAG,  UCSR0A,1<<5},
  {TXC0_FLAG,   UCSR0A,1<<6},
  {RXC0_FLAG,   UCSR0A,1<<7},

  {TXB80_FLAG,  UCSR0B,1<<0},
  {RXB80_FLAG,  UCSR0B,1<<1},
  {CHR90_FLAG,  UCSR0B,1<<2},
  {TXEN0_FLAG,  UCSR0B,1<<3},
  {RXEN0_FLAG,  UCSR0B,1<<4},
  {UDRIE0_FLAG, UCSR0B,1<<5},
  {TXCIE0_FLAG, UCSR0B,1<<6},
  {RXCIE0_FLAG, UCSR0B,1<<7},

  {ACIS0_FLAG, ACSR,  1<<0},
  {ACIS1_FLAG, ACSR,  1<<1},
  {ACIC_FLAG,  ACSR,  1<<2},
  {ACIE_FLAG,  ACSR,  1<<3},
  {ACI_FLAG,   ACSR,  1<<4},
  {ACO_FLAG,   ACSR,  1<<5},
  {ACD_FLAG,   ACSR,  1<<7},

  {MUX0_FLAG,  ADMUX, 1<<0},
  {MUX1_FLAG,  ADMUX, 1<<1},
  {MUX2_FLAG,  ADMUX, 1<<2},

  {ADPS0_FLAG, ADCSR, 1<<0},
  {ADPS1_FLAG, ADCSR, 1<<1},
  {ADPS2_FLAG, ADCSR, 1<<2},
  {ADIE_FLAG,  ADCSR, 1<<3},
  {ADIF_FLAG,  ADCSR, 1<<4},
  {ADSC_FLAG,  ADCSR, 1<<6},
  {ADEN_FLAG,  ADCSR, 1<<7},
  {-1,-1}
};
